//+------------------------------------------------------------------+
//|                                                           CC.mq4 |
//|                                              SemSemFX@rambler.ru |
//|              http://onix-trade.net/forum/index.php?showtopic=107 |
//+------------------------------------------------------------------+
#property copyright "SemSemFX@rambler.ru"
#property link      "http://onix-trade.net/forum/index.php?showtopic=107"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1  LimeGreen
#property indicator_color2  Aqua
#property indicator_color3  Red
#property indicator_color4  Gray
#property indicator_color5  Orange
#property indicator_color6  DarkOrange
#property indicator_color7  Magenta
#property indicator_color8  Teal


//---- parameters
extern string  TimeFrame = "240";
extern int     MA_Method=3;
extern int     Price=6;
extern string  prefix="";
extern string  suffix="ct";
extern bool    USD = 1;
extern bool    EUR = 0;
extern bool    GBP = 0;
extern bool    CHF = 0;
extern bool    JPY = 0;
extern bool    AUD = 0;
extern bool    CAD = 0;
extern bool    NZD = 1;
extern color   Color_USD = LimeGreen;
extern color   Color_EUR = Aqua;
extern color   Color_GBP = Red;
extern color   Color_CHF = Gray;
extern color   Color_JPY = Orange;
extern color   Color_AUD = DarkOrange;
extern color   Color_CAD = Magenta;
extern color   Color_NZD = Teal;
extern int     Line_Thickness = 0;
extern int     Bars.Count = 100;

// for monthly
extern int     mn_per = 12;
extern int     mn_fast = 3;
// for weekly
extern int     w_per = 9;
extern int     w_fast = 3;
// for daily
extern int     d_per = 5;
extern int     d_fast = 3;
// for H4
extern int     h4_per = 7;
extern int     h4_fast = 2;
// for H1
extern int     h1_per = 24;
extern int     h1_fast = 8;
// for M30
extern int     m30_per = 16;
extern int     m30_fast = 2;
// for M15
extern int     m15_per = 16;
extern int     m15_fast = 4;
// for M5
extern int     m5_per = 12;
extern int     m5_fast = 3;
// for M1
extern int     m1_per = 30;
extern int     m1_fast = 10;
extern bool    Interpolate=true;

double arrUSD[];
double arrEUR[];
double arrGBP[];
double arrCHF[];
double arrJPY[];
double arrAUD[];
double arrCAD[];
double arrNZD[];

int timeFrame;
string Indicator_Name="CC:    ";
int Objs=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   if (USD)Indicator_Name=StringConcatenate(Indicator_Name," USD");
   if (EUR)Indicator_Name=StringConcatenate(Indicator_Name," EUR");
   if (GBP)Indicator_Name=StringConcatenate(Indicator_Name," GBP");
   if (CHF)Indicator_Name=StringConcatenate(Indicator_Name," CHF");
   if (AUD)Indicator_Name=StringConcatenate(Indicator_Name," AUD");
   if (CAD)Indicator_Name=StringConcatenate(Indicator_Name," CAD");
   if (JPY)Indicator_Name=StringConcatenate(Indicator_Name," JPY");
   if (NZD)Indicator_Name=StringConcatenate(Indicator_Name," NZD");
   
      timeFrame = stringToTimeFrame(TimeFrame);
      string tfDesc = " - "+timeFrameToString(timeFrame);
      Indicator_Name = Indicator_Name+tfDesc;
         IndicatorShortName(Indicator_Name);
   int cur=0; 
   int st=23; 
   if (USD){sl("~",cur,Color_USD);cur+=st;}
   if (EUR){sl("~",cur,Color_EUR);cur+=st;}
   if (GBP){sl("~",cur,Color_GBP);cur+=st;}
   if (CHF){sl("~",cur,Color_CHF);cur+=st;}
   if (AUD){sl("~",cur,Color_AUD);cur+=st;}
   if (CAD){sl("~",cur,Color_CAD);cur+=st;}
   if (JPY){sl("~",cur,Color_JPY);cur+=st;}
   if (NZD){sl("~",cur,Color_NZD);cur+=st;}
   
      
   int width=0;
   if(0>StringFind(Symbol(),"USD",0))width=0;else width=Line_Thickness;
   SetIndexStyle(0,DRAW_LINE,DRAW_LINE,width,Color_USD);
   SetIndexBuffer(0,arrUSD);
   SetIndexLabel(0, "USD"); 
   if(0>StringFind(Symbol(),"EUR",0))width=0;else width=Line_Thickness;
   SetIndexStyle(1,DRAW_LINE,DRAW_LINE,width,Color_EUR);
   SetIndexBuffer(1,arrEUR);
   SetIndexLabel(1, "EUR"); 
   if(0>StringFind(Symbol(),"GBP",0))width=0;else width=Line_Thickness;
   SetIndexStyle(2,DRAW_LINE,DRAW_LINE,width,Color_GBP);
   SetIndexBuffer(2,arrGBP);
   SetIndexLabel(2, "GBP"); 
   if(0>StringFind(Symbol(),"CHF",0))width=0;else width=Line_Thickness;
   SetIndexStyle(3,DRAW_LINE,DRAW_LINE,width,Color_CHF);
   SetIndexBuffer(3,arrCHF);
   SetIndexLabel(3, "CHF"); 
   if(0>StringFind(Symbol(),"JPY",0))width=0;else width=Line_Thickness;
   SetIndexStyle(4,DRAW_LINE,DRAW_LINE,width,Color_JPY);
   SetIndexBuffer(4,arrJPY);
   SetIndexLabel(4, "JPY"); 
   if(0>StringFind(Symbol(),"AUD",0))width=0;else width=Line_Thickness;
   SetIndexStyle(5,DRAW_LINE,DRAW_LINE,width,Color_AUD);
   SetIndexBuffer(5,arrAUD);
   SetIndexLabel(5, "AUD"); 
   if(0>StringFind(Symbol(),"CAD",0))width=0;else width=Line_Thickness;
   SetIndexStyle(6,DRAW_LINE,DRAW_LINE,width,Color_CAD);
   SetIndexBuffer(6,arrCAD);
   SetIndexLabel(6, "CAD"); 
   if(0>StringFind(Symbol(),"NZD",0))width=0;else width=Line_Thickness;
   SetIndexStyle(7,DRAW_LINE,DRAW_LINE,width,Color_NZD);
   SetIndexBuffer(7,arrNZD);
   SetIndexLabel(7, "NZD"); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   for(int i=0; i<Objs; i++){
      if(!ObjectDelete(Indicator_Name+i))
         Print("error: code #",GetLastError());
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
     int limit;
     int counted_bars=IndicatorCounted();
   double f1, f2, kp, kp2;
   string tr, tr2;
 
     
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars+Bars.Count;
     int Slow,Fast;
     color wt;
     switch(timeFrame)
       {
         case 1:     Slow = m1_per; Fast = m1_fast; break;
         case 5:     Slow = m5_per; Fast = m5_fast; break;
         case 15:    Slow = m15_per;Fast = m15_fast; break;
         case 30:    Slow = m30_per;Fast = m30_fast; break;
         case 60:    Slow = h1_per; Fast = h1_fast; break;
         case 240:   Slow = h4_per; Fast = h4_fast; break;
         case 1440:  Slow = d_per;  Fast = d_fast; break;
         case 10080: Slow = w_per;  Fast = w_fast; break;
         case 43200: Slow = mn_per; Fast = mn_fast; break;
       }
 //----  
     for(int i=limit; i>=0; i--) {
      //  
      if (EUR){
         double EURUSD_Fast=ma(prefix+"EURUSD"+suffix,Fast,MA_Method,Price,i);
         double EURUSD_Slow=ma(prefix+"EURUSD"+suffix,Slow,MA_Method,Price,i);
         if (!EURUSD_Fast || !EURUSD_Slow)continue;
      }
      if (GBP){
         double GBPUSD_Fast=ma(prefix+"GBPUSD"+suffix,Fast,MA_Method,Price,i);
         double GBPUSD_Slow=ma(prefix+"GBPUSD"+suffix,Slow,MA_Method,Price,i);
         if (!GBPUSD_Fast || !GBPUSD_Slow)continue;
      }
      if (AUD){
         double AUDUSD_Fast=ma(prefix+"AUDUSD"+suffix,Fast,MA_Method,Price,i);
         double AUDUSD_Slow=ma(prefix+"AUDUSD"+suffix,Slow,MA_Method,Price,i);
         if (!AUDUSD_Fast || !AUDUSD_Slow)continue;
      }
      if (NZD){
         double NZDUSD_Fast=ma(prefix+"NZDUSD"+suffix,Fast,MA_Method,Price,i);
         double NZDUSD_Slow=ma(prefix+"NZDUSD"+suffix,Slow,MA_Method,Price,i);
         if (!NZDUSD_Fast || !NZDUSD_Slow)continue;
      }
      if (CAD){
         double USDCAD_Fast=ma(prefix+"USDCAD"+suffix,Fast,MA_Method,Price,i);
         double USDCAD_Slow=ma(prefix+"USDCAD"+suffix,Slow,MA_Method,Price,i);
         if (!USDCAD_Fast || !USDCAD_Slow)continue;
      }
      if (CHF){
         double USDCHF_Fast=ma(prefix+"USDCHF"+suffix,Fast,MA_Method,Price,i);
         double USDCHF_Slow=ma(prefix+"USDCHF"+suffix,Slow,MA_Method,Price,i);
         if (!USDCHF_Fast || !USDCHF_Slow)continue;
      }
      if (JPY){
         double USDJPY_Fast=ma(prefix+"USDJPY"+suffix,Fast,MA_Method,Price,i)/100;
         double USDJPY_Slow=ma(prefix+"USDJPY"+suffix,Slow,MA_Method,Price,i)/100;
         if (!USDJPY_Fast || !USDJPY_Slow)continue;
      }
      // currencies calculation 
      
      if (USD){
         arrUSD[i]=0;
         if (EUR) arrUSD[i]+=EURUSD_Slow-EURUSD_Fast;
         if (GBP) arrUSD[i]+=GBPUSD_Slow-GBPUSD_Fast;
         if (CHF) arrUSD[i]+=USDCHF_Fast-USDCHF_Slow;
         if (JPY) arrUSD[i]+=USDJPY_Fast-USDJPY_Slow;
         if (AUD) arrUSD[i]+=AUDUSD_Slow-AUDUSD_Fast;
         if (CAD) arrUSD[i]+=USDCAD_Fast-USDCAD_Slow;
         if (NZD) arrUSD[i]+=NZDUSD_Slow-NZDUSD_Fast;
      }// end if USD
      if (EUR){
         arrEUR[i]=0;
         if (USD) arrEUR[i]+=EURUSD_Fast-EURUSD_Slow;
         if (GBP) arrEUR[i]+=(EURUSD_Fast/GBPUSD_Fast-EURUSD_Slow/GBPUSD_Slow)*ma(prefix+"EURUSD"+suffix,1,MA_Method,Price,i);
         if (CHF) arrEUR[i]+=(EURUSD_Fast*USDCHF_Fast-EURUSD_Slow*USDCHF_Slow)*ma(prefix+"EURUSD"+suffix,1,MA_Method,Price,i);
         if (JPY) arrEUR[i]+=(EURUSD_Fast*USDJPY_Fast-EURUSD_Slow*USDJPY_Slow)*ma(prefix+"EURUSD"+suffix,1,MA_Method,Price,i);
         if (AUD) arrEUR[i]+=(EURUSD_Fast/AUDUSD_Fast-EURUSD_Slow/AUDUSD_Slow)*ma(prefix+"EURUSD"+suffix,1,MA_Method,Price,i);
         if (CAD) arrEUR[i]+=(EURUSD_Fast*USDCAD_Fast-EURUSD_Slow*USDCAD_Slow)*ma(prefix+"EURUSD"+suffix,1,MA_Method,Price,i);
         if (NZD) arrEUR[i]+=(EURUSD_Fast/NZDUSD_Fast-EURUSD_Slow/NZDUSD_Slow)*ma(prefix+"EURUSD"+suffix,1,MA_Method,Price,i);
      
      }// end if EUR
      if (GBP){
         arrGBP[i]=0;
         if (USD) arrGBP[i]+=GBPUSD_Fast-GBPUSD_Slow;
         if (EUR) arrGBP[i]+=(EURUSD_Slow/GBPUSD_Slow-EURUSD_Fast/GBPUSD_Fast)*ma(prefix+"GBPUSD"+suffix,1,MA_Method,Price,i);
         if (CHF) arrGBP[i]+=(GBPUSD_Fast*USDCHF_Fast-GBPUSD_Slow*USDCHF_Slow)*ma(prefix+"GBPUSD"+suffix,1,MA_Method,Price,i);
         if (JPY) arrGBP[i]+=(GBPUSD_Fast*USDJPY_Fast-GBPUSD_Slow*USDJPY_Slow)*ma(prefix+"GBPUSD"+suffix,1,MA_Method,Price,i);
         if (AUD) arrGBP[i]+=(GBPUSD_Fast/AUDUSD_Fast-GBPUSD_Slow/AUDUSD_Slow)*ma(prefix+"GBPUSD"+suffix,1,MA_Method,Price,i);
         if (CAD) arrGBP[i]+=(GBPUSD_Fast*USDCAD_Fast-GBPUSD_Slow*USDCAD_Slow)*ma(prefix+"GBPUSD"+suffix,1,MA_Method,Price,i);
         if (NZD) arrGBP[i]+=(GBPUSD_Fast/NZDUSD_Fast-GBPUSD_Slow/NZDUSD_Slow)*ma(prefix+"GBPUSD"+suffix,1,MA_Method,Price,i);
      
      }// end if GBP        
      if (CHF){
         arrCHF[i]=0;
         if (USD) arrCHF[i]+=USDCHF_Slow-USDCHF_Fast;
         if (EUR) arrCHF[i]+=(EURUSD_Slow*USDCHF_Slow-EURUSD_Fast*USDCHF_Fast)*ma(prefix+"USDCHF"+suffix,1,MA_Method,Price,i);
         if (GBP) arrCHF[i]+=(GBPUSD_Slow*USDCHF_Slow-GBPUSD_Fast*USDCHF_Fast)*ma(prefix+"USDCHF"+suffix,1,MA_Method,Price,i);
         if (JPY) arrCHF[i]+=(USDJPY_Fast/USDCHF_Fast-USDJPY_Slow/USDCHF_Slow)*ma(prefix+"USDCHF"+suffix,1,MA_Method,Price,i);
         if (AUD) arrCHF[i]+=(AUDUSD_Slow*USDCHF_Slow-AUDUSD_Fast*USDCHF_Fast)*ma(prefix+"USDCHF"+suffix,1,MA_Method,Price,i);
         if (CAD) arrCHF[i]+=(USDCHF_Slow/USDCAD_Slow-USDCHF_Fast/USDCAD_Fast)*ma(prefix+"USDCHF"+suffix,1,MA_Method,Price,i);
         if (NZD) arrCHF[i]+=(NZDUSD_Slow*USDCHF_Slow-NZDUSD_Fast*USDCHF_Fast)*ma(prefix+"USDCHF"+suffix,1,MA_Method,Price,i);
      }// end if CHF
      if (JPY){
         arrJPY[i]=0;
         if (USD) arrJPY[i]+=USDJPY_Slow-USDJPY_Fast;
         if (EUR) arrJPY[i]+=(EURUSD_Slow*USDJPY_Slow-EURUSD_Fast*USDJPY_Fast)*ma(prefix+"USDJPY"+suffix,1,MA_Method,Price,i)/100;
         if (GBP) arrJPY[i]+=(GBPUSD_Slow*USDJPY_Slow-GBPUSD_Fast*USDJPY_Fast)*ma(prefix+"USDJPY"+suffix,1,MA_Method,Price,i)/100;
         if (CHF) arrJPY[i]+=(USDJPY_Slow/USDCHF_Slow-USDJPY_Fast/USDCHF_Fast)*ma(prefix+"USDJPY"+suffix,1,MA_Method,Price,i)/100;
         if (AUD) arrCHF[i]+=(AUDUSD_Slow*USDJPY_Slow-AUDUSD_Fast*USDJPY_Fast)*ma(prefix+"USDJPY"+suffix,1,MA_Method,Price,i)/100;
         if (CAD) arrCHF[i]+=(USDJPY_Slow/USDCAD_Slow-USDJPY_Fast/USDCAD_Fast)*ma(prefix+"USDJPY"+suffix,1,MA_Method,Price,i)/100;
         if (NZD) arrCHF[i]+=(NZDUSD_Slow*USDJPY_Slow-NZDUSD_Fast*USDJPY_Fast)*ma(prefix+"USDJPY"+suffix,1,MA_Method,Price,i)/100;
      }// end if JPY

      if (CAD){
         arrCAD[i] = 0;
         if(USD) arrCAD[i]+=USDCAD_Slow-USDCAD_Fast;
         if(EUR) arrCAD[i]+=(EURUSD_Slow*USDCAD_Slow-EURUSD_Fast*USDCAD_Fast)*ma(prefix+"USDCAD"+suffix,1,MA_Method,Price,i);
         if(GBP) arrCAD[i]+=(GBPUSD_Slow*USDCAD_Slow-GBPUSD_Fast*USDCAD_Fast)*ma(prefix+"USDCAD"+suffix,1,MA_Method,Price,i);
         if(CHF) arrCAD[i]+=(USDCHF_Fast/USDCAD_Fast-USDCHF_Slow/USDCAD_Slow)*ma(prefix+"USDCAD"+suffix,1,MA_Method,Price,i);
         if(JPY) arrCAD[i]+=(USDJPY_Fast/USDCAD_Fast-USDJPY_Slow/USDCAD_Slow)*ma(prefix+"USDCAD"+suffix,1,MA_Method,Price,i);
         if(AUD) arrCAD[i]+=(AUDUSD_Slow*USDCAD_Slow-AUDUSD_Fast*USDCAD_Fast)*ma(prefix+"USDCAD"+suffix,1,MA_Method,Price,i);
         if(NZD) arrCAD[i]+=(NZDUSD_Slow*USDCAD_Slow-NZDUSD_Fast*USDCAD_Fast)*ma(prefix+"USDCAD"+suffix,1,MA_Method,Price,i);
      }// end if CAD
     
      if (AUD){  
           arrAUD[i] = 0;
           if(USD) arrAUD[i]+=AUDUSD_Fast-AUDUSD_Slow;
           if(EUR) arrAUD[i]+=(EURUSD_Slow/AUDUSD_Slow-EURUSD_Fast/AUDUSD_Fast)*ma(prefix+"AUDUSD"+suffix,1,MA_Method,Price,i);
           if(GBP) arrAUD[i]+=(GBPUSD_Slow/AUDUSD_Slow-GBPUSD_Fast/AUDUSD_Fast)*ma(prefix+"AUDUSD"+suffix,1,MA_Method,Price,i);
           if(NZD) arrAUD[i]+=(AUDUSD_Fast/NZDUSD_Fast-AUDUSD_Slow/NZDUSD_Slow)*ma(prefix+"AUDUSD"+suffix,1,MA_Method,Price,i);
           if(CHF) arrAUD[i]+=(AUDUSD_Fast*USDCHF_Fast-AUDUSD_Slow*USDCHF_Slow)*ma(prefix+"AUDUSD"+suffix,1,MA_Method,Price,i);
           if(CAD) arrAUD[i]+=(AUDUSD_Fast*USDCAD_Fast-AUDUSD_Slow*USDCAD_Slow)*ma(prefix+"AUDUSD"+suffix,1,MA_Method,Price,i);
           if(JPY) arrAUD[i]+=(AUDUSD_Fast*USDJPY_Fast-AUDUSD_Slow*USDJPY_Slow)*ma(prefix+"AUDUSD"+suffix,1,MA_Method,Price,i);
       }// end if AUD
       
       if (NZD){
           arrNZD[i] = 0;
           if(USD) arrNZD[i]+=NZDUSD_Fast-NZDUSD_Slow;
           if(EUR) arrNZD[i]+=(EURUSD_Slow/NZDUSD_Slow-EURUSD_Fast/NZDUSD_Fast)*ma(prefix+"NZDUSD"+suffix,1,MA_Method,Price,i);
           if(GBP) arrNZD[i]+=(GBPUSD_Slow/NZDUSD_Slow-GBPUSD_Fast/NZDUSD_Fast)*ma(prefix+"NZDUSD"+suffix,1,MA_Method,Price,i);
           if(AUD) arrNZD[i]+=(AUDUSD_Slow/NZDUSD_Slow-AUDUSD_Fast/NZDUSD_Fast)*ma(prefix+"NZDUSD"+suffix,1,MA_Method,Price,i);
           if(CHF) arrNZD[i]+=(NZDUSD_Fast*USDCHF_Fast-NZDUSD_Slow*USDCHF_Slow)*ma(prefix+"NZDUSD"+suffix,1,MA_Method,Price,i);
           if(CAD) arrNZD[i]+=(NZDUSD_Fast*USDCAD_Fast-NZDUSD_Slow*USDCAD_Slow)*ma(prefix+"NZDUSD"+suffix,1,MA_Method,Price,i);
           if(JPY) arrNZD[i]+=(NZDUSD_Fast*USDJPY_Fast-NZDUSD_Slow*USDJPY_Slow)*ma(prefix+"NZDUSD"+suffix,1,MA_Method,Price,i);
       }// end if NZD
       
         if (timeFrame <= Period() || !Interpolate || iBarShift(NULL,timeFrame,Time[i])==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,iBarShift(NULL,timeFrame,Time[i]));
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               if (USD) arrUSD[i+k] = arrUSD[i] + (arrUSD[i+n]-arrUSD[i])*k/n;
               if (EUR) arrEUR[i+k] = arrEUR[i] + (arrEUR[i+n]-arrEUR[i])*k/n;
               if (GBP) arrGBP[i+k] = arrGBP[i] + (arrGBP[i+n]-arrGBP[i])*k/n;
               if (JPY) arrJPY[i+k] = arrJPY[i] + (arrJPY[i+n]-arrJPY[i])*k/n;
               if (CHF) arrCHF[i+k] = arrCHF[i] + (arrCHF[i+n]-arrCHF[i])*k/n;
               if (AUD) arrAUD[i+k] = arrAUD[i] + (arrAUD[i+n]-arrAUD[i])*k/n;
               if (CAD) arrCAD[i+k] = arrCAD[i] + (arrCAD[i+n]-arrCAD[i])*k/n;
               if (NZD) arrNZD[i+k] = arrNZD[i] + (arrNZD[i+n]-arrNZD[i])*k/n;
            }

     }//end block for(int i=0; i<limit; i++)
    string para="",para2=""; 
    f1=0; f2=0;
//--- EUR:     
     // Eur/Usd
     if(EUR)
     {
     if(USD) {kp=(arrEUR[0]-arrEUR[1])-(arrUSD[0]-arrUSD[1]);
          if (MathAbs(kp)>f1)
           {para2=para; f2=f1; tr2=tr; para="EUR/USD"; f1=MathAbs(kp);
             if (kp>0) tr="buy"; if (kp<0) tr="sell";}}
     // Eur/Gbp    
     if(GBP) {kp=(arrEUR[0]-arrEUR[1])-(arrGBP[0]-arrGBP[1]);
          if (MathAbs(kp)>f1)
           {para2=para; f2=f1; tr2=tr; para="EUR/GBP"; f1=MathAbs(kp);
             if (kp>0) tr="buy"; if (kp<0) tr="sell";}}
     // Eur/Chf    
     if(CHF) {kp=(arrEUR[0]-arrEUR[1])-(arrCHF[0]-arrCHF[1]);
          if (MathAbs(kp)>f1)
           {para2=para; f2=f1; tr2=tr; para="EUR/CHF"; f1=MathAbs(kp);
             if (kp>0) tr="buy"; if (kp<0) tr="sell";}}
     // Eur/Jpy    
     if(JPY) {kp=(arrEUR[0]-arrEUR[1])-(arrJPY[0]-arrJPY[1]);
          if (MathAbs(kp)>f1)
           {para2=para; f2=f1; tr2=tr; para="EUR/JPY"; f1=MathAbs(kp);
             if (kp>0) tr="buy"; if (kp<0) tr="sell";}}
     // Eur/Cad  
     if(CAD) {kp=(arrEUR[0]-arrEUR[1])-(arrCAD[0]-arrCAD[1]);
          if (MathAbs(kp)>f1)
           {para2=para; f2=f1; tr2=tr; para="EUR/CAD"; f1=MathAbs(kp);
             if (kp>0) tr="buy"; if (kp<0) tr="sell";}}
     // Eur/Aud
     if(AUD) {kp=(arrEUR[0]-arrEUR[1])-(arrAUD[0]-arrAUD[1]);
          if (MathAbs(kp)>f1)
           {para2=para; f2=f1; tr2=tr; para="EUR/AUD"; f1=MathAbs(kp);
             if (kp>0) tr="buy"; if (kp<0) tr="sell";}}
     // Eur/Nzd
     if(NZD) {kp=(arrEUR[0]-arrEUR[1])-(arrNZD[0]-arrNZD[1]);
          if (MathAbs(kp)>f1)
           {para2=para; f2=f1; tr2=tr; para="EUR/NZD"; f1=MathAbs(kp);
             if (kp>0) tr="buy"; if (kp<0) tr="sell";}}
     }        
//--- GBP:      
     
     if(GBP)
     {
     // Gbp/Usd    
     if(USD) {kp=(arrGBP[0]-arrGBP[1])-(arrUSD[0]-arrUSD[1]);
          if (MathAbs(kp)>f1)
            {para2=para; f2=f1; tr2=tr; para="GBP/USD"; f1=MathAbs(kp);
             if (kp>0) tr="buy"; if (kp<0) tr="sell";}}
     // Gbp/Chf    
     if(CHF) {kp=(arrGBP[0]-arrGBP[1])-(arrCHF[0]-arrCHF[1]);
          if (MathAbs(kp)>f1)
           {para2=para; f2=f1; tr2=tr; para="GBP/CHF"; f1=MathAbs(kp);
             if (kp>0) tr="buy"; if (kp<0) tr="sell";}}
     // Gbp/Jpy
     if(JPY) {kp=(arrGBP[0]-arrGBP[1])-(arrJPY[0]-arrJPY[1]);
          if (MathAbs(kp)>f1)
           {para2=para; f2=f1; tr2=tr; para="GBP/JPY"; f1=MathAbs(kp);
             if (kp>0) tr="buy"; if (kp<0) tr="sell";}}
     // Gbp/Cad  
     if(CAD) {kp=(arrGBP[0]-arrGBP[1])-(arrCAD[0]-arrCAD[1]);
          if (MathAbs(kp)>f1)
           {para2=para; f2=f1; tr2=tr; para="GBP/CAD"; f1=MathAbs(kp);
             if (kp>0) tr="buy"; if (kp<0) tr="sell";}}
     // Gbp/Aud
     if(AUD) {kp=(arrGBP[0]-arrGBP[1])-(arrAUD[0]-arrAUD[1]);
          if (MathAbs(kp)>f1)
           {para2=para; f2=f1; tr2=tr; para="GBP/AUD"; f1=MathAbs(kp);
             if (kp>0) tr="buy"; if (kp<0) tr="sell";}}
     // Gbp/Nzd
     if(NZD) {kp=(arrGBP[0]-arrGBP[1])-(arrNZD[0]-arrNZD[1]);
          if (MathAbs(kp)>f1)
           {para2=para; f2=f1; tr2=tr; para="GBP/NZD"; f1=MathAbs(kp);
             if (kp>0) tr="buy"; if (kp<0) tr="sell";}}
     }        
//--- CHF:             
     
     if(CHF)
     {
     // Usd/Chf    
     if(USD) {kp=(arrUSD[0]-arrUSD[1])-(arrCHF[0]-arrCHF[1]);
          if (MathAbs(kp)>f1)
           {para2=para; f2=f1; tr2=tr; para="USD/CHF"; f1=MathAbs(kp);
            if (kp>0) tr="buy"; if (kp<0) tr="sell";}}
               
     if(JPY) {kp=(arrCHF[0]-arrCHF[1])-(arrJPY[0]-arrJPY[1]);
          if (MathAbs(kp)>f1)
           {para2=para; f2=f1; tr2=tr; para="CHF/JPY"; f1=MathAbs(kp);
            if (kp>0) tr="buy"; if (kp<0) tr="sell";}}                  
     
     if(AUD) {kp=(arrAUD[0]-arrAUD[1])-(arrCHF[0]-arrCHF[1]);
          if (MathAbs(kp)>f1)
           {para2=para; f2=f1; tr2=tr; para="AUD/CHF"; f1=MathAbs(kp);
            if (kp>0) tr="buy"; if (kp<0) tr="sell";}}

     if(NZD) {kp=(arrNZD[0]-arrNZD[1])-(arrCHF[0]-arrCHF[1]);
          if (MathAbs(kp)>f1)
           {para2=para; f2=f1; tr2=tr; para="NZD/CHF"; f1=MathAbs(kp);
            if (kp>0) tr="buy"; if (kp<0) tr="sell";}}
     
     if(CAD) {kp=(arrCAD[0]-arrCAD[1])-(arrCHF[0]-arrCHF[1]);
          if (MathAbs(kp)>f1)
           {para2=para; f2=f1; tr2=tr; para="CAD/CHF"; f1=MathAbs(kp);
            if (kp>0) tr="buy"; if (kp<0) tr="sell";}}
     }       
            
//---JPY:     
     if(JPY)
     {
     // Usd/Jpy    
     if(USD) {kp=(arrUSD[0]-arrUSD[1])-(arrJPY[0]-arrJPY[1]);
          if (MathAbs(kp)>f1)
           {para2=para; f2=f1; tr2=tr; para="USD/JPY"; f1=MathAbs(kp);
            if (kp>0) tr="buy"; if (kp<0) tr="sell";}}                             
               
     if(AUD) {kp=(arrAUD[0]-arrAUD[1])-(arrJPY[0]-arrJPY[1]);
          if (MathAbs(kp)>f1)
           {para2=para; f2=f1; tr2=tr; para="AUD/JPY"; f1=MathAbs(kp);
            if (kp>0) tr="buy"; if (kp<0) tr="sell";}}                             
     
     if(NZD) {kp=(arrNZD[0]-arrNZD[1])-(arrJPY[0]-arrJPY[1]);
          if (MathAbs(kp)>f1)
           {para2=para; f2=f1; tr2=tr; para="NZD/JPY"; f1=MathAbs(kp);
            if (kp>0) tr="buy"; if (kp<0) tr="sell";}}
            
     if(CAD) {kp=(arrCAD[0]-arrCAD[1])-(arrJPY[0]-arrJPY[1]);
          if (MathAbs(kp)>f1)
           {para2=para; f2=f1; tr2=tr; para="CAD/JPY"; f1=MathAbs(kp);
            if (kp>0) tr="buy"; if (kp<0) tr="sell";}}                  
     } 
//---AUD:     
     if(AUD)
     {
     // Aud/Usd    
     if(USD) {kp=(arrAUD[0]-arrAUD[1])-(arrUSD[0]-arrUSD[1]);
          if (MathAbs(kp)>f1)
           {para2=para; f2=f1; tr2=tr; para="AUD/USD"; f1=MathAbs(kp);
            if (kp>0) tr="buy"; if (kp<0) tr="sell";}}                             
               
     if(NZD) {kp=(arrAUD[0]-arrAUD[1])-(arrNZD[0]-arrNZD[1]);
          if (MathAbs(kp)>f1)
           {para2=para; f2=f1; tr2=tr; para="AUD/NZD"; f1=MathAbs(kp);
            if (kp>0) tr="buy"; if (kp<0) tr="sell";}}                             
     
     if(CAD) {kp=(arrAUD[0]-arrAUD[1])-(arrCAD[0]-arrCAD[1]);
          if (MathAbs(kp)>f1)
           {para2=para; f2=f1; tr2=tr; para="AUD/CAD"; f1=MathAbs(kp);
            if (kp>0) tr="buy"; if (kp<0) tr="sell";}}      
     }
     
//---CAD:     
     if(CAD) 
     {
     // Usd/Cad       
     if(USD) {kp=(arrUSD[0]-arrUSD[1])-(arrCAD[0]-arrCAD[1]);
          if (MathAbs(kp)>f1)
           {para2=para; f2=f1; tr2=tr; para="USD/CAD"; f1=MathAbs(kp);
            if (kp>0) tr="buy"; if (kp<0) tr="sell";}}
            
     if(NZD) {kp=(arrNZD[0]-arrNZD[1])-(arrCAD[0]-arrCAD[1]);
          if (MathAbs(kp)>f1)
           {para2=para; f2=f1; tr2=tr; para="NZD/CAD"; f1=MathAbs(kp);
            if (kp>0) tr="buy"; if (kp<0) tr="sell";}}
     }                           
  
//---NZD:     
     if(NZD)
     {
     // Nzd/Usd       
     if(USD) {kp=(arrNZD[0]-arrNZD[1])-(arrUSD[0]-arrUSD[1]);
          if (MathAbs(kp)>f1)
           {para2=para; f2=f1; tr2=tr; para="NZD/USD"; f1=MathAbs(kp);
            if (kp>0) tr="buy"; if (kp<0) tr="sell";}}
     }       
         
    
      
  //----
      ObjectDelete("ob"); 
      ObjectDelete("ob1"); 
      ObjectDelete("ob2"); 
      
      if(para != "" && NormalizeDouble(f1,4) > 0)
      {
      
      ObjectCreate("ob", OBJ_LABEL, 1, 0, 0);
      ObjectSet("ob", OBJPROP_CORNER, 1);
      ObjectSet("ob", OBJPROP_XDISTANCE, 5);
      ObjectSet("ob", OBJPROP_YDISTANCE, 2);
      ObjectSetText("ob", para, 12, "Arial Black", White);  
      if (tr=="buy") wt=LimeGreen; else wt=Red;
      
      ObjectCreate("ob1", OBJ_LABEL, 1, 0, 0);
      ObjectSet("ob1", OBJPROP_CORNER, 1);
      ObjectSet("ob1", OBJPROP_XDISTANCE, 5);
      ObjectSet("ob1", OBJPROP_YDISTANCE, 22);
      ObjectSetText("ob1", tr, 12, "Arial Black", wt);
      
      ObjectCreate("ob2", OBJ_LABEL, 1, 0, 0);
      ObjectSet("ob2", OBJPROP_CORNER, 1);
      ObjectSet("ob2", OBJPROP_XDISTANCE, 5);
      ObjectSet("ob2", OBJPROP_YDISTANCE, 42);
      tr=DoubleToStr(f1,4);
      ObjectSetText("ob2", tr, 10, "Arial Black", DodgerBlue);
      }
      
                  
      ObjectDelete("ob3"); 
      ObjectDelete("ob4");
      ObjectDelete("ob5"); 
      
      if(para != para2 && NormalizeDouble(f2,4) > 0)
      {
      //Print(para,"_",para2);
      
      ObjectCreate("ob3", OBJ_LABEL, 1, 0, 0);
      ObjectSet("ob3", OBJPROP_CORNER, 3);
      ObjectSet("ob3", OBJPROP_XDISTANCE, 5);
      ObjectSet("ob3", OBJPROP_YDISTANCE, 42);
      ObjectSetText("ob3", para2, 12, "Arial Black", White);  
      if (tr2=="buy") wt=LimeGreen; else wt=Red;
       
      ObjectCreate("ob4", OBJ_LABEL, 1, 0, 0);
      ObjectSet("ob4", OBJPROP_CORNER, 3);
      ObjectSet("ob4", OBJPROP_XDISTANCE, 5);
      ObjectSet("ob4", OBJPROP_YDISTANCE, 22);
      ObjectSetText("ob4", tr2, 12, "Arial Black", wt);
      
      ObjectCreate("ob5", OBJ_LABEL, 1, 0, 0);
      ObjectSet("ob5", OBJPROP_CORNER, 3);
      ObjectSet("ob5", OBJPROP_XDISTANCE, 5);
      ObjectSet("ob5", OBJPROP_YDISTANCE, 2);
      tr=DoubleToStr(f2,4);
      ObjectSetText("ob5", tr, 10, "Arial Black", DodgerBlue);
      }
      
   return(0);
  }
//+------------------------------------------------------------------+

// Subroutines
double ma(string sym, int per, int Mode, int Price, int i){
   return(iMA(sym,timeFrame,per,0,Mode,Price,iBarShift(sym,timeFrame,Time[i])));
}   

void sl(string sym, int y, color col){
   int window=WindowFind(Indicator_Name);
   string ID=Indicator_Name+Objs;
   Print("ID:",ID);
   int tmp=10+y;
   Objs++;
   if (ObjectCreate(ID, OBJ_LABEL, window, 0, 0)){
      //ObjectSet(ID, OBJPROP_CORNER, 1);
      ObjectSet(ID, OBJPROP_XDISTANCE, y+35);
      ObjectSet(ID, OBJPROP_YDISTANCE, 0);
      ObjectSetText(ID, sym, 18, "Arial Black", col); 
   }
}   

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}